/*
 * Created on 11.02.2005
 *
 */
package net.sit.dialog.cli;

import java.awt.BorderLayout;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;

import org.apache.log4j.Logger;

/**
 * @author Christoph Sandhaus
 */
public class ClientGui implements ComponentListener {

	static Logger logger = Logger.getLogger(ClientGui.class.getName());

	private static final long serialVersionUID = 3256442521143030329L;

	private JFrame frame;

	private JList list;

	private String serverIp;

	private Config cfg;

	public ClientGui(Vector message_list, final String serverIp) {
		// Elemente initialisieren
		this.serverIp = serverIp;
		this.cfg = Config.getInstance();

		/** Den Frame erzeugen */
		frame = new JFrame("Dialog Client (" + serverIp + ")");
		frame.setSize(cfg.getFrameSize());
		frame.setLocation(cfg.getFramePosition());

		/** Frame Gre/Position speichern, wenn diese Daten sich ndern */
		frame.addComponentListener(this);

		/** Die Liste mit den Meldungen erzeugen */
		logger.debug("Anzahl Nachrichtenobjekte: " + message_list.size());
		list = new JList(message_list);
		list.setVisibleRowCount(-1);
		JScrollPane listScroller = new JScrollPane(list);
		// listScroller.setPreferredSize(new Dimension(250, 80));

		/** Den Doppelklich fr die Liste konfigurieren */
		list.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2) {
					ClientRMIConnector crc = new ClientRMIConnector(serverIp);
					try {
						Object selectedValue = list.getSelectedValue();
						if (selectedValue != null)
							crc.displayMessageDialog(selectedValue.toString());
					} catch (ServerDownException e1) {
						logger.debug("Server nicht erreichbar");
						messageDialog("Server nicht erreichbar");
					}
				}
			}

		});
		listScroller.setAlignmentX(JDialog.LEFT_ALIGNMENT);

		// ums aussehen kmmern
		frame.getContentPane().setLayout(new BorderLayout());

		// elemente dem frame hinzufgen. reihenfolge!!
		frame.getContentPane().add(listScroller, BorderLayout.CENTER);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		// frame.pack();
		frame.setVisible(true);
	}

	private void messageDialog(String string) {
	}

	public void componentHidden(ComponentEvent e) {
	}

	public void componentMoved(ComponentEvent e) {
		cfg.setFramePosition(frame.getLocationOnScreen());
	}

	public void componentResized(ComponentEvent e) {
		cfg.setFrameSize(frame.getSize());
	}

	public void componentShown(ComponentEvent e) {
	}

}
