package net.sit.dialog.srv;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author Christoph Sandhaus
 *         <p>
 *         In einem Remote-Interface werden eine oder mehrere Methoden
 *         definiert, die als aufrufbare Dienste anderen Arbeitspltzen zur
 *         Verfgung gestellt werden sollen.
 *         <p>
 *         Das Interface <b>mu </b> das Interface Remote erweitern, die
 *         Methoden <b>mssen </b> RemoteExceptions werfen.
 */

public interface DialogServerIF extends Remote {

	/**
	 * Remote Methode zum Anzeigen der bermittelten Nachricht.
	 * 
	 * @param message
	 *            die anzuzeigende Nachricht
	 * @return true bei Erfolg, sonst false
	 * @throws RemoteException
	 *             <p>
	 *             Diese Methode ruft im Zielsystem das Shellskript 'syscall.sh'
	 *             auf und bergibt die Zeichenkette 'message' als Parameter an
	 *             das Skript. Das Skript startet dann einen Systemdialog, in
	 *             der die Nachricht angezeigt wird. Da das Skript vom User nach
	 *             Belieben gendert werden kann, kann auch auf andere Weise
	 *             reagiert werden.
	 */
	public boolean displayMessageDialog(String message) throws RemoteException;
}
